//
//  DCMotorController.h
//  DCMotor
//
//  Created by Phidgets on 2015-07-28.
//  Copyright (c) 2015 Phidgets. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <Phidget22/phidget22.h>
#import "PhidgetInfoBox.h"

@interface DCMotorController : NSObject <NSWindowDelegate>
{
    IBOutlet NSWindow *mainWindow;
    PhidgetDCMotorHandle ch;
    //PhidgetInfoBox View
    IBOutlet PhidgetInfoBox *phidgetInfoBoxView;
    IBOutlet NSBox *phidgetInfoBox;
    //Settings
    IBOutlet NSBox *settingsBox;
    IBOutlet NSSlider *velocitySlider;
    IBOutlet NSTextField *velocityText;
    IBOutlet NSSlider *accelerationSlider;
    IBOutlet NSTextField *accelerationMinLabel;
    IBOutlet NSTextField *accelerationMaxLabel;
    IBOutlet NSTextField *accelerationText;
    IBOutlet NSButton *backEMFCheck;
    //Braking Strength
    IBOutlet NSBox *brakingStrengthBox;
    IBOutlet NSSlider *brakingStrengthSlider;
    IBOutlet NSTextField *brakingStrengthText;
    //DCC1000 specific
    IBOutlet NSBox *extraSettingsBox;
    IBOutlet NSTextField *currentLimitLabel;
    IBOutlet NSSlider *currentLimitSlider;
    IBOutlet NSTextField *currentLimitMinLabel;
    IBOutlet NSTextField *currentLimitMaxLabel;
    NSTextField *currentRegulatorGainLabel;
    NSSlider *currentRegulatorGainSlider;
    NSTextField *currentRegulatorGainMinLabel;
    NSTextField *currentRegulatorGainMaxLabel;
    NSComboBox *fanModeCombo;
    
    //Velocity Change Event
    IBOutlet NSBox *velocityChangeBox;
    IBOutlet NSTextField *velocityChangeText;
    //Back EMF Event
    IBOutlet NSBox *backEMFBox;
    IBOutlet NSTextField *backEMFText;
    //Braking Strength Event
    IBOutlet NSBox *brakingStrengthChangeBox;
    IBOutlet NSTextField *brakingStrengthChangeLabel;
    //Errors
    IBOutlet NSPanel *errorEventLogWindow;
    IBOutlet NSTextView *errorEventLog;
    IBOutlet NSTextField *errorEventLogCounter;
}

@end
